# CPET-563 Project Charter

## Project Creation Details

| Project Name | CPET-563 CV Object Detection |
| --- | --- |
| **Project Manager** | Isaac Southwell |
| **Project Sponsor** | Dr. Kaputa |
| **Project Charter Creation Date** | 02/12/2024 |
| **Project Approval Date** | TBD |

##

## Project Team

| Team Member | Name | Primary Role | Secondary Role |
| --- | --- | --- | --- | --- |
| 1.  | Joe Demaria | Algorithm (Tennis Ball Calculations) | FPGA (Image Processing) | 
| 2.  | Connor Ott | FPGA (Image Processing) | Algorithm (Tennis Ball Calculations) | 
| 3.  | Andrew Sealing | Unity (World Server) | FPGA (Image Processing) | 
| 4.  | Blizzard Finnegan | Communications Layer / Data Visualization | Business |
| 5.  | Isaac Southwell | Business | Communications Layer / Data Visualization |
| 6.  | Wesley Madden | Unity (World Server) | Float | 
##

## Project Parameters

### Problem Statement

    During amateur and professional tennis matches, some serves or returns land near the boundary of the field-of-play. The high velocity of the tennis ball makes accurate human determinations of tennis ball position during bounce impossible.

### Project Goal

    Design and implement a computer-vision object detection system to determine the in-bounds validity of a tennis ball bounce on a court.

### Project Objectives

- Create an object detection system that can output a visualization of the tennis ball's movement within 3 seconds.
  
- Have the system determine the X, Y, and Z positions of the ball at the location of bounce. For all provided test data, decisively (with 95% certainty) conclude whether the bounce was in or out of bounds.
  
- Ensure the algorithmic results are within 5% accuracy of determining in- or out-of-bounds tennis ball movement (matches certainty of the decision).
  
- Implement the entire project without cost overruns or time extensions.
  
- Remain organized with team project files, zero major codebase version control issues.
  
- Accurately track labor of all team members and submit 'paychecks' on time to each individual.
  
- Produce and turn in all deliverables by the final project due date.
  

### Project Strategies

- Capture the motion of the tennis ball using two unity cameras, export image data to FPGA.
  
- Use MATLAB or GNU Octane to create a skeleton for visualizing the processed motion of the tennis ball.
  
- Shift to a webserver front-end using Javascript for final tennis ball modeling and prediction.
  
- Implement statistics within the image processing algorithm to determine object-detection certainty.
  
- Track all labor with Forgejo issue-tracking or pre-planning time document.
  
- Follow good-practice repo habits, and consult online documentation as needed to ensure proper version control.
  
- Track progress with milestones and timelines, publicly accessable by all team members.
  

### Project Scope

    The project will feature a virtual stereo camera that captures an tennis ball moving in a Unity world server. Image data will be sent to the FPGA for image processing.

    For a hardware image processing implementation, the image data can be handed to the FPGA by loading the data into the VDMA buffer. After processing, the derived centroid and position data will be loaded back into the VDMA buffer and accessed by the webserver for final visualization.

| Project Parameter | Fit and Usage |
| --- | --- |
| Problem Statement |     |
| Project Goal |     |
| Project Objectives |     |
| Project Description |     |
| Scope |     |
| Business Case |     |
| Constraints |     |
| Project Deliverables |     |
| Metrics |     |

### Business Case

    The quick determination of where a tennis ball makes it's bounce is consequential -- for humans deciding the result, there's no statistical evaluation or visualization of where the ball landed. Mistakes on rulings happen often, even with a discrete truth: the ball landed either in bounds, or out of bounds.

   Options to employ people for watching the tennis court bounds exist, however a competent object detection system would function with no induced bias. Creating a realtime or near-realtime system that can adequately show the ball's path of travel will be tremendously helpful for any company, team, or host trying to create the most fair tennis game.

### Constraints

#### Time

- The team must convene to reach the project-start milestone by 02/28/2024 at the latest.
  
- The team will have until have all parts working and integrated (5) days before the project due date, to allow for time to finish organizing and polishing deliverables.
  
- Final Project due date is :
  

#### Cost

- Labor shall not exceed 200 total hours / $20,000. TODO: Determine total reasonable amount of hours.
  
- Initial budget must be signed off by Project Sponsor.
  

#### Scope

- Individual tasks not in CPET-563 Work Breakdown Structure are not included within project. TODO: Transition tasks to Forejo issue tracker / define as work packages
  
- Scope creep should be evaluated by the whole team as it propogates.
  

### Project Deliverables

#### Project Demonstration

    The project should be demonstrated to the Stakeholders / Project Sponsor, as part of a final evaluation of our success.

#### Code Repository

    Repositories for all created code should be made available for access under GPLv3 license.

#### Business Documents

- Pre-development documents
  
  - CPET-563 Project Charter
    
  - CPET-563 Budget
    
- Post-development documents
  
  - CPET-563 Statistical Results
    
  - CPET-563 Financial Report
    
  - CPET-563 Project Team Retrospective